CON

{{SidPlayer v. 0.03 ALPHA}}

  _clkmode = xtal1+pll16x
  '_clkfreq = 117_964_800
  '_clkfreq = 100_000_000
  _clkfreq = 80_000_000

  _SD_DO = 0
  _SD_CLK = 1
  _SD_DI = 2
  _SD_CS = 3
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.



  rightPin = 10
  leftPin  = 11

var
byte cmdbuf[81]
byte cmdbuf2[81]
byte cptr
byte buffer2[25]
byte namebuf[200*32]
long pos
byte playrate
byte il

OBJ

  kbm           : "kbm"
  vga           : "vn2032-20120613"
  fat           : "kyefat"
  sid           : "sidcog"

pub start | char, mx, my, dmx,dmy, buffer, i, x,y,code,s1,s2,g

s2:=string("Scanning...")
s1:=string("SidPlay v. 0.03 Alpha")

' start components

kbm.start(24,25,26,27)
vga.start
sid.start(rightPin, leftPin)
fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1)

'wait until they starts...

waitcnt(clkfreq*3 + cnt)

'mount a SD

vga.writeln(string("Mounting SD card... press RESET if this text don't disappear"))
fat.mountPartition(0)
vga.cls
vga.cursoroff
waitcnt(clkfreq*3+cnt)

vga.outtextxy (40-(strsize(s1)>>1),0,s1)  'need to add function for centered text to VGA driver
repeat i from 5 to 15
  vga.setfontcolor(0,i,0,3,0)             'need to add colored text output function

vga.outtextxy(34,1,s2)
repeat i from 5 to 15
  vga.setfontcolor(1,i,3,0,0)

il:=scan-1

repeat i from 0 to il
'  vga.writeln(vga.inttostr(i))
  x:=(i/25)*20+2
  y:=(i//25)+3'
  vga.outtextxy(x,y,@namebuf+32*i+15)

pos:=0

repeat i from 0 to 4
  vga.setfontcolor(3,i,3,3,0)
  vga.setbackcolor(3,i,0,2,0)

repeat

  if char:=kbm.key
    if char==$c3
      x:=(pos/25)*5
      y:=(pos//25)+3
      repeat i from 0 to 4
        vga.setfontcolor(y,i+x,2,3,3)
        vga.setbackcolor(y,i+x,0,0,1)
      pos+=1
      if pos>il
        pos:=0
      x:=(pos/25)*5
      y:=(pos//25)+3
      repeat i from 0 to 4
        vga.setfontcolor(y,i+x,3,3,0)
        vga.setbackcolor(y,i+x,0,2,0)


    if char==$c2
      x:=(pos/25)*5
      y:=(pos//25)+3
      repeat i from 0 to 4
        vga.setfontcolor(y,i+x,2,3,3)
        vga.setbackcolor(y,i+x,0,0,1)
      pos-=1
      if pos<0
        pos:=il
      x:=(pos/25)*5
      y:=(pos//25)+3
      repeat i from 0 to 4
        vga.setfontcolor(y,i+x,3,3,0)
        vga.setbackcolor(y,i+x,0,2,0)


    if char==$c1
      x:=(pos/25)*5
      y:=(pos//25)+3
      repeat i from 0 to 4
        vga.setfontcolor(y,i+x,2,3,3)
        vga.setbackcolor(y,i+x,0,0,1)
      pos+=25
      if pos>il
        pos:=il
      x:=(pos/25)*5
      y:=(pos//25)+3
      repeat i from 0 to 4
        vga.setfontcolor(y,i+x,3,3,0)
        vga.setbackcolor(y,i+x,0,2,0)


    if char==$c0
      x:=(pos/25)*5
      y:=(pos//25)+3
      repeat i from 0 to 4
        vga.setfontcolor(y,i+x,2,3,3)
        vga.setbackcolor(y,i+x,0,0,1)
      pos-=25
      if pos<0
        pos:=0
      if pos>il
        pos:=il
      x:=(pos/25)*5
      y:=(pos//25)+3
      repeat i from 0 to 4
        vga.setfontcolor(y,i+x,3,3,0)
        vga.setbackcolor(y,i+x,0,2,0)

    if char==13
      repeat
        code:=playcmd
      until code==-1


pub playcmd |c, ch, x,y,i,qqq,qq

\fat.openfile(@namebuf+32*pos,"r")

playrate:=namebuf[32*pos+14]
c:=fat.readdata(@buffer2,25)
if c<>25
  vga.write(string("File not found - "))
  vga.write(@cmdbuf)
  bytefill(@cmdbuf,0,81)
  bytefill(@cmdbuf2,0,81)
  cptr:=0
  vga.writeln(string(" "))
  vga.writeln(string(" "))
  vga.write(string("C:\>"))
  return
vga.outtextxy(20,29,string("Playing file "))
vga.outtextxy(33,29,string("                "))
vga.outtextxy(33,29,@namebuf+32*pos+15)
  repeat i from 0 to 12
    vga.setfontcolor(29,i,3,1,0)

repeat
  waitcnt(cnt + (clkfreq/playRate))
  c:=fat.readdata(@buffer2,25)
  sid.updateRegisters(@buffer2)
  ch:=kbm.key


'*********************


      if ch==$c3
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos+=1
        if pos>il
          pos:=0
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if ch==$c2
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos-=1
        if pos<0
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if ch==$c1
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos+=25
        if pos>il
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


      if ch==$c0
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,2,3,3)
          vga.setbackcolor(y,i+x,0,0,1)
        pos-=25
        if pos<0
          pos:=0
        if pos>il
          pos:=il
        x:=(pos/25)*5
        y:=(pos//25)+3
        repeat i from 0 to 4
          vga.setfontcolor(y,i+x,3,3,0)
          vga.setbackcolor(y,i+x,0,2,0)


'*******************


until (c<>25) or (ch==$263) or (ch==13)
fat.closefile
bytefill(@buffer2,0,25)
sid.updateRegisters(@buffer2)

if ch==13
  return pos
else
  return -1



pub  scan|i,buffer,c,freq,l

i:=0

fat.listEntries("W")
repeat while(buffer := fat.listEntries("N"))
  l:=11
  repeat while byte[buffer+l]==32
    byte[buffer+l]:=0
    l-=1
  l:=strsize(buffer)
  if strcomp(buffer+l-4,string(".DMP"))
    bytemove(@namebuf+(32*i),buffer,13)
    \fat.openfile(buffer,"r")
    c:=fat.readdata(@buffer2,25)
    if c==25
      if (buffer2[0]=="S") and (buffer2[1]=="D") and (buffer2[2]=="M") and (buffer2[3]=="P")
        freq:=buffer2[4]
        namebuf[32*i+14]:=freq
        bytemove(@namebuf+32*i+15,@buffer2+8,16)
      else
        byte[buffer+l-4]:=0
        bytemove(@namebuf+32*i+15,buffer,l)
        namebuf[32*i+14]:=50
      i:=i+1
      vga.outtextxy(45,1,vga.inttostr(i))
    if i>99
      quit

vga.outtextxy(34,1, string("                  "))
result:=i


